; ##############################################################################
; ##############################################################################
; ##############################################################################
LED_7SEGMENT_INITIALISIERUNG:
	; PORTS fr 7-SEGMENT								
	sbi PORT_DDR_DIG_0,PIN_DIG_0
	sbi PORT_DDR_DIG_1,PIN_DIG_1
	sbi PORT_DDR_DIG_2,PIN_DIG_2
	sbi PORT_DDR_DIG_3,PIN_DIG_3
	sbi PORT_DDR_DIG_4,PIN_DIG_4
	sbi PORT_DDR_DIG_5,PIN_DIG_5

	sbi PORT_DDR_BALKEN_A,PIN_BALKEN_A
	sbi PORT_DDR_BALKEN_B,PIN_BALKEN_B
	sbi PORT_DDR_BALKEN_C,PIN_BALKEN_C
	sbi PORT_DDR_BALKEN_D,PIN_BALKEN_D
	sbi PORT_DDR_BALKEN_E,PIN_BALKEN_E
	sbi PORT_DDR_BALKEN_F,PIN_BALKEN_F
	sbi PORT_DDR_BALKEN_G,PIN_BALKEN_G
	sbi PORT_DDR_BALKEN_P,PIN_BALKEN_P
	; alle DIGITS an				
	sbi PORT_DIG_0,PIN_DIG_0
	sbi PORT_DIG_1,PIN_DIG_1	
	sbi PORT_DIG_2,PIN_DIG_2	
	sbi PORT_DIG_3,PIN_DIG_3	
	sbi PORT_DIG_4,PIN_DIG_4
	sbi PORT_DIG_5,PIN_DIG_5
	; alle BALKEN an				
	cbi PORT_BALKEN_A,PIN_BALKEN_A	
	cbi PORT_BALKEN_B,PIN_BALKEN_B	
	cbi PORT_BALKEN_C,PIN_BALKEN_C	
	cbi PORT_BALKEN_D,PIN_BALKEN_D	
	cbi PORT_BALKEN_E,PIN_BALKEN_E	
	cbi PORT_BALKEN_F,PIN_BALKEN_F	
	cbi PORT_BALKEN_G,PIN_BALKEN_G	
	cbi PORT_BALKEN_P,PIN_BALKEN_P

	rcall wait_100ms

	; alles aus 
	cbi PORT_DIG_0,PIN_DIG_0
	cbi PORT_DIG_1,PIN_DIG_1	
	cbi PORT_DIG_2,PIN_DIG_2	
	cbi PORT_DIG_3,PIN_DIG_3	
	cbi PORT_DIG_4,PIN_DIG_4
	cbi PORT_DIG_5,PIN_DIG_5
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
LED_ALLE_AUS:
	STS (adr_LED_BYTE_0),NULL
	STS (adr_LED_BYTE_1),NULL
	STS (adr_LED_BYTE_2),NULL
	STS (adr_LED_BYTE_3),NULL
	STS (adr_LED_BYTE_4),NULL
	STS (adr_LED_BYTE_5),NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Balken einzeln																
LED_7SEGMENT_TEST_A:
	ldi temp,1
LED_7SEGMENT_TEST_A_s:
	rcall LED_7SEGMENT_TEST_A_ACTION	
	ROL temp
	tst temp
	brne LED_7SEGMENT_TEST_A_s
	rcall LED_7SEGMENT_TEST_A_ACTION	
	ret
LED_7SEGMENT_TEST_A_ACTION:
	STS (adr_LED_BYTE_0),temp
	rcall wait_10ms
	STS (adr_LED_BYTE_1),temp
	rcall wait_10ms
	STS (adr_LED_BYTE_2),temp
	rcall wait_10ms
	STS (adr_LED_BYTE_3),temp
	rcall wait_10ms
	STS (adr_LED_BYTE_4),temp
	rcall wait_10ms
	STS (adr_LED_BYTE_5),temp
	rcall wait_100ms
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; "543210"																		
LED_7SEGMENT_TEST_B:
	; "543210"					
	ldi temp1,BYTE1(543210)
	ldi temp2,BYTE2(543210)
	ldi temp3,BYTE3(543210)
	ldi temp4,BYTE4(543210)
	rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...8
	STS (adr_LED_BYTE_0),temp1
	rcall wait_100ms
	STS (adr_LED_BYTE_1),temp2
	rcall wait_100ms
	STS (adr_LED_BYTE_2),temp3
	rcall wait_100ms
	STS (adr_LED_BYTE_3),temp4
	rcall wait_100ms
	STS (adr_LED_BYTE_4),temp5
	rcall wait_100ms
	STS (adr_LED_BYTE_5),temp6
	rcall wait_100ms
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
; HELLIGKEIT																
LED_7SEGMENT_TEST_C:
	LDS temp3,(adr_LED_HELLIGKEITSWERT)

	ldi temp,6
LED_7SEGMENT_TEST_s1:
	STS(adr_LED_HELLIGKEITSWERT),temp
	rcall wait_100ms
	inc temp
	cpi temp,50
	brlo LED_7SEGMENT_TEST_s1

	rcall wait_100ms
	STS(adr_LED_HELLIGKEITSWERT),temp3
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
; 09.2016																	
LED_VERSION_ANZEIGEN:
	ldi temp,(ZAHL_6)
	STS (adr_LED_BYTE_0),temp
	ldi temp,(ZAHL_1)
	STS (adr_LED_BYTE_1),temp
	ldi temp,(ZAHL_0)
	STS (adr_LED_BYTE_2),temp
	ldi temp,(ZAHL_2)
	STS (adr_LED_BYTE_3),temp
	ldi temp,(ZAHL_9)
	ori temp,0b10000000		; PUNKT	
	STS (adr_LED_BYTE_4),temp
	ldi temp,(ZAHL_0)
	STS (adr_LED_BYTE_5),temp
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
LED_TESTWERT_ANZEIGEN:
	; INVERTIERMODUS
	LDS temp1,(adr_DCF_ERROR_CODE)			; aus SRAM laden	
	clr temp2
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...8
	STS (adr_LED_BYTE_0),temp1
	STS (adr_LED_BYTE_1),temp2
	STS (adr_LED_BYTE_2),temp3

	ldi temp,'-'
	rcall FUNKTION_7_SEGMENT
	STS (adr_LED_BYTE_3),temp
	STS (adr_LED_BYTE_4),temp
	STS (adr_LED_BYTE_5),temp
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
LED_ERROR_ANZEIGEN:
	LDS temp1,(adr_DCF_ERROR_CODE)			; aus SRAM laden	
	clr temp2
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...8
	STS (adr_LED_BYTE_0),temp1
	STS (adr_LED_BYTE_1),temp2
	STS (adr_LED_BYTE_2),temp3
	STS (adr_LED_BYTE_3),NULL
	STS (adr_LED_BYTE_4),NULL

	ldi temp,(ZEICHEN_E)
	STS (adr_LED_BYTE_5),temp

ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
LED_ZEIT_ANZEIGEN:
	; SEKUNDEN	
	LDS temp1,(adr_ss)			; aus SRAM laden	
	clr temp2
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...8
	STS (adr_LED_BYTE_0),temp1
	STS (adr_LED_BYTE_1),temp2
	; Minuten	
	LDS temp1,(adr_mm)			; aus SRAM laden	
	clr temp2
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...8
	ori temp1,0b10000000		; PUNKT	
	STS (adr_LED_BYTE_2),temp1
	STS (adr_LED_BYTE_3),temp2
	; Stunden	
	LDS temp1,(adr_hh)			; aus SRAM laden	
	clr temp2
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...8
	ori temp1,0b10000000		; PUNKT	
	STS (adr_LED_BYTE_4),temp1
	STS (adr_LED_BYTE_5),temp2
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
LED_DATUM_ANZEIGEN:
	; JAHR		
	LDS temp1,(adr_JAHR)			; aus SRAM laden	
	clr temp2
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...8
	STS (adr_LED_BYTE_0),temp1
	STS (adr_LED_BYTE_1),temp2
	; Monat		
	LDS temp1,(adr_MONAT)			; aus SRAM laden	
	clr temp2
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...8
	ori temp1,0b10000000		; PUNKT	
	STS (adr_LED_BYTE_2),temp1
	STS (adr_LED_BYTE_3),temp2
	; TAG		
	LDS temp1,(adr_TAG)			; aus SRAM laden	
	clr temp2
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...8
	ori temp1,0b10000000		; PUNKT	
	STS (adr_LED_BYTE_4),temp1
	STS (adr_LED_BYTE_5),temp2

ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
;																			
;	Value: 0...	99.999.999													
;																			
;	INPUT: 	temp1	(BYTE1)													
;	 		temp2	(BYTE2)													
;			temp3	(BYTE3)													
;			temp4	(BYTE4)													
;																			
;	OUTPUT:	temp1	(		   1-er Stelle)									
;			temp2	(		  10-er Stelle)									
;			temp3	(        100-er Stelle)									
;			temp4	(      1.000-er Stelle)									
;			temp5	(     10.000-er Stelle)									
;			temp6	(    100.000-er Stelle)									
;			temp7	(  1.000.000-er Stelle)									
;			temp8	( 10.000.000-er Stelle)									
; 																			
; rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...8			
; 																			
FUNKTION_HEX_ASC_32:
	clr temp
FUNKTION_HEX_ASC_10000000:; 10.000.000
	inc temp
	subi temp1, BYTE1    (10000000)
	sbci temp2, BYTE2    (10000000)
	sbci temp3, BYTE3    (10000000)
	sbci temp4, BYTE4    (10000000)
	brcc FUNKTION_HEX_ASC_10000000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp8) auf dem Stack sichern            
	subi temp1, BYTE1   (-10000000)
	sbci temp2, BYTE2   (-10000000)
	sbci temp3, BYTE3   (-10000000)
	sbci temp4, BYTE4   (-10000000)
	clr temp
FUNKTION_HEX_ASC_1000000:
	inc temp
	subi temp1, BYTE1    (1000000)
	sbci temp2, BYTE2    (1000000)
	sbci temp3, BYTE3    (1000000)
	brcc FUNKTION_HEX_ASC_1000000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp7) auf dem Stack sichern            
	subi temp1, BYTE1   (-1000000)
	sbci temp2, BYTE2   (-1000000)
	sbci temp3, BYTE3   (-1000000)
	clr temp
FUNKTION_HEX_ASC_100000:
	inc temp
	subi temp1, BYTE1    (100000)
	sbci temp2, BYTE2    (100000)
	sbci temp3, BYTE3    (100000)
	brcc FUNKTION_HEX_ASC_100000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp6) auf dem Stack sichern            
	subi temp1, BYTE1   (-100000)
	sbci temp2, BYTE2   (-100000)
	sbci temp3, BYTE3   (-100000)
	clr temp
FUNKTION_HEX_ASC_10000:
	inc temp
	subi temp1, BYTE1    (10000)
	sbci temp2, BYTE2    (10000)
	sbci temp3, BYTE3    (10000)
	brcc FUNKTION_HEX_ASC_10000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp5) auf dem Stack sichern            
	subi temp1, BYTE1  (-10000)
	sbci temp2, BYTE2  (-10000)
	sbci temp3, BYTE3  (-10000)
	clr temp
FUNKTION_HEX_ASC_1000:
	inc temp
	subi temp1, low  (1000)
	sbci temp2, HIGH (1000)
	brcc FUNKTION_HEX_ASC_1000
	dec temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp4) auf dem Stack sichern            
	subi temp1, low  (-1000)
	sbci temp2, HIGH (-1000)
	clr temp
FUNKTION_HEX_ASC_100:
	inc temp
	subi temp1, low  (100)
	sbci temp2, HIGH (100)
	brcc FUNKTION_HEX_ASC_100
	dec temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp3) auf dem Stack sichern            
	subi temp1, low  (-100)
	sbci temp2, HIGH (-100)
	clr temp
FUNKTION_HEX_ASC_10:
	inc temp
	subi temp1, low  (10)
	sbci temp2, HIGH (10)
	brcc FUNKTION_HEX_ASC_10
	dec temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp2) auf dem Stack sichern            
	subi temp1, low  (-10)
	sbci temp2, HIGH (-10)
FUNKTION_HEX_ASC_1:	
	subi temp1, -48		; HEX->ASC

	pop	TEMP2			; LESEN vom STACK (KOPIE)
	pop	TEMP3			; LESEN vom STACK (KOPIE)
	pop	TEMP4			; LESEN vom STACK (KOPIE)
	pop	TEMP5			; LESEN vom STACK (KOPIE)
	pop	TEMP6			; LESEN vom STACK (KOPIE)
	pop	TEMP7			; LESEN vom STACK (KOPIE)
	pop	TEMP8			; LESEN vom STACK (KOPIE)

; Umwandlung auf 7 Segment	
	mov temp,temp1				; temp1			
	rcall FUNKTION_7_SEGMENT 	; inp/out: temp	
	mov temp1,temp
	mov temp,temp2				; temp2			
	rcall FUNKTION_7_SEGMENT 	; inp/out: temp	
	mov temp2,temp
	mov temp,temp3				; temp3			
	rcall FUNKTION_7_SEGMENT 	; inp/out: temp	
	mov temp3,temp
	mov temp,temp4				; temp4			
	rcall FUNKTION_7_SEGMENT 	; inp/out: temp	
	mov temp4,temp
	mov temp,temp5				; temp5			
	rcall FUNKTION_7_SEGMENT 	; inp/out: temp	
	mov temp5,temp
	mov temp,temp6				; temp6			
	rcall FUNKTION_7_SEGMENT 	; inp/out: temp	
	mov temp6,temp
	mov temp,temp7				; temp7			
	rcall FUNKTION_7_SEGMENT 	; inp/out: temp	
	mov temp7,temp
	mov temp,temp8				; temp8			
	rcall FUNKTION_7_SEGMENT 	; inp/out: temp	
	mov temp8,temp

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
FUNKTION_7_SEGMENT:
	cpi temp,'0'
	breq FUNKTION_7_SEGMENT_0
	cpi temp,'1'
	breq FUNKTION_7_SEGMENT_1
	cpi temp,'2'
	breq FUNKTION_7_SEGMENT_2
	cpi temp,'3'
	breq FUNKTION_7_SEGMENT_3
	cpi temp,'4'
	breq FUNKTION_7_SEGMENT_4
	cpi temp,'5'
	breq FUNKTION_7_SEGMENT_5
	cpi temp,'6'
	breq FUNKTION_7_SEGMENT_6
	cpi temp,'7'
	breq FUNKTION_7_SEGMENT_7
	cpi temp,'8'
	breq FUNKTION_7_SEGMENT_8
	cpi temp,'9'
	breq FUNKTION_7_SEGMENT_9
	cpi temp,'-'
	breq FUNKTION_7_SEGMENT_MINUS
	cpi temp,'A'
	breq FUNKTION_7_SEGMENT_A
	cpi temp,'B'
	breq FUNKTION_7_SEGMENT_B
	cpi temp,'C'
	breq FUNKTION_7_SEGMENT_C
	; ERROR
	ldi temp, (ZEICHEN_E)
	ret
FUNKTION_7_SEGMENT_0:
	ldi temp, (ZAHL_0)
	ret
FUNKTION_7_SEGMENT_1:
	ldi temp, (ZAHL_1)
	ret
FUNKTION_7_SEGMENT_2:
	ldi temp, (ZAHL_2)
	ret
FUNKTION_7_SEGMENT_3:
	ldi temp, (ZAHL_3)
	ret
FUNKTION_7_SEGMENT_4:
	ldi temp, (ZAHL_4)
	ret
FUNKTION_7_SEGMENT_5:
	ldi temp, (ZAHL_5)
	ret
FUNKTION_7_SEGMENT_6:
	ldi temp, (ZAHL_6)
	ret
FUNKTION_7_SEGMENT_7:
	ldi temp, (ZAHL_7)
	ret
FUNKTION_7_SEGMENT_8:
	ldi temp, (ZAHL_8)
	ret
FUNKTION_7_SEGMENT_9:
	ldi temp, (ZAHL_9)
	ret
FUNKTION_7_SEGMENT_MINUS:
	ldi temp, (ZEICHEN_MINUS)
	ret
FUNKTION_7_SEGMENT_A:
	ldi temp, (ZEICHEN_A)
	ret
FUNKTION_7_SEGMENT_B:
	ldi temp, (ZEICHEN_B)
	ret
FUNKTION_7_SEGMENT_C:
	ldi temp, (ZEICHEN_C)
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DIGIT:
	LDS temp,(adr_LED_DIGIT_ZAEHLER)	; ZHLER laden		
	inc temp							; +1	
	; HELLIGKEIT		
	LDS temp1,(adr_LED_HELLIGKEITSWERT)
	cp temp,temp1						; vergleich 		
	brlo DIGIT_w						; ist kleiner		
	clr temp
DIGIT_w:
	STS (adr_LED_DIGIT_ZAEHLER),temp	; ZHLER schreiben	
; ------------------------------------------------------------------------------
	; ZHLER				
	cpi temp,0
	breq DIGIT_0
	cpi temp,1
	breq DIGIT_1
	cpi temp,2
	breq DIGIT_2
	cpi temp,3
	breq DIGIT_3
	cpi temp,4
	breq DIGIT_4
	cpi temp,5
	breq DIGIT_5
	; alles aus				
	cbi PORT_DIG_0,PIN_DIG_0		; DIGIT 1 OFF		
	cbi PORT_DIG_1,PIN_DIG_1
	cbi PORT_DIG_2,PIN_DIG_2
	cbi PORT_DIG_3,PIN_DIG_3
	cbi PORT_DIG_4,PIN_DIG_4
	cbi PORT_DIG_5,PIN_DIG_5
	ret
; ------------------------------------------------------------------------------
DIGIT_0:
	cbi PORT_DIG_5,PIN_DIG_5	; DIGIT 5 aus	
	LDS temp1,(adr_LED_BYTE_0)	; BALKEN laden	
	rcall BALKEN				; BALKEN setzen	
	sbi PORT_DIG_0,PIN_DIG_0	; DIGIT 0 an	
	ret
DIGIT_1:
	cbi PORT_DIG_0,PIN_DIG_0
	LDS temp1,(adr_LED_BYTE_1)
	rcall BALKEN
	sbi PORT_DIG_1,PIN_DIG_1	
	ret
DIGIT_2:
	cbi PORT_DIG_1,PIN_DIG_1
	LDS temp1,(adr_LED_BYTE_2)
	rcall BALKEN
	sbi PORT_DIG_2,PIN_DIG_2	
	ret
DIGIT_3:
	cbi PORT_DIG_2,PIN_DIG_2
	LDS temp1,(adr_LED_BYTE_3)
	rcall BALKEN
	sbi PORT_DIG_3,PIN_DIG_3	
	ret
DIGIT_4:
	cbi PORT_DIG_3,PIN_DIG_3
	LDS temp1,(adr_LED_BYTE_4)
	rcall BALKEN
	sbi PORT_DIG_4,PIN_DIG_4	
	ret
DIGIT_5:
	cbi PORT_DIG_4,PIN_DIG_4
	LDS temp1,(adr_LED_BYTE_5)
	rcall BALKEN
	sbi PORT_DIG_5,PIN_DIG_5	
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BALKEN:
	sbrs temp1,0
	sbi PORT_BALKEN_A,PIN_BALKEN_A	; Balken "A" off	
	sbrc temp1,0
	cbi PORT_BALKEN_A,PIN_BALKEN_A	; Balken "A" on		

	sbrs temp1,1
	sbi PORT_BALKEN_B,PIN_BALKEN_B	
	sbrc temp1,1
	cbi PORT_BALKEN_B,PIN_BALKEN_B	

	sbrs temp1,2
	sbi PORT_BALKEN_C,PIN_BALKEN_C
	sbrc temp1,2
	cbi PORT_BALKEN_C,PIN_BALKEN_C	

	sbrs temp1,3
	sbi PORT_BALKEN_C,PIN_BALKEN_D
	sbrc temp1,3
	cbi PORT_BALKEN_D,PIN_BALKEN_D	

	sbrs temp1,4
	sbi PORT_BALKEN_C,PIN_BALKEN_E
	sbrc temp1,4
	cbi PORT_BALKEN_E,PIN_BALKEN_E	

	sbrs temp1,5
	sbi PORT_BALKEN_C,PIN_BALKEN_F
	sbrc temp1,5
	cbi PORT_BALKEN_F,PIN_BALKEN_F	

	sbrs temp1,6
	sbi PORT_BALKEN_C,PIN_BALKEN_G
	sbrc temp1,6
	cbi PORT_BALKEN_G,PIN_BALKEN_G	

	sbrs temp1,7
	sbi PORT_BALKEN_C,PIN_BALKEN_P
	sbrc temp1,7
	cbi PORT_BALKEN_A,PIN_BALKEN_P	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
